/* This script upgrades configuration database v2.5 to v4.1 */
SET TERM ^;
SET AUTODDL ON^

ALTER TABLE REPL$CONFIG ADD FKBEHAVIOR INTEGER DEFAULT 0 NOT NULL,
 ADD FPS_TIMEOUT INTEGER DEFAULT 0 NOT NULL^

ALTER TABLE REPL$DATABASES ADD MOREPARAMS BLOB SUB_TYPE TEXT^

ALTER TABLE REPL$RELATIONS ADD RELATIONSCHEMA VARCHAR(100) CHARACTER SET NONE,
 ADD TARGETSCHEMA VARCHAR(100) CHARACTER SET NONE,
 ADD CONFLICTMETHOD INTEGER DEFAULT -1 NOT NULL,
 ADD FKBEHAVIOR INTEGER DEFAULT -1 NOT NULL^

UPDATE REPL$RELATIONS SET CONFLICTMETHOD=-1^
UPDATE REPL$RELATIONS SET FKBEHAVIOR=-1^

CREATE TABLE REPL$SEQUENCES (
  REPLNO INTEGER NOT NULL,
  TGTDBNO INTEGER NOT NULL,
  SEQNO INTEGER NOT NULL CONSTRAINT REPL$SEQ_PK PRIMARY KEY,
  SOURCESCHEMA VARCHAR(100) CHARACTER SET NONE DEFAULT '' NOT NULL,
  SOURCENAME VARCHAR(100) CHARACTER SET NONE NOT NULL,
  TARGETSCHEMA VARCHAR(100) CHARACTER SET NONE DEFAULT '' NOT NULL,
  TARGETNAME VARCHAR(100) CHARACTER SET NONE NOT NULL,
  CONSTRAINT REPL$C_SEQ_SUBSCRIBED FOREIGN KEY (REPLNO, TGTDBNO) REFERENCES REPL$SUBSCRIBEDDB)^

INSERT INTO REPL$KEYWORDS VALUES (1,'ACCESS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ADD')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ALL')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ALTER')^
INSERT INTO REPL$KEYWORDS VALUES (1,'AND')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ANY')^
INSERT INTO REPL$KEYWORDS VALUES (1,'AS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ASC')^
INSERT INTO REPL$KEYWORDS VALUES (1,'AUDIT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'BETWEEN')^
INSERT INTO REPL$KEYWORDS VALUES (1,'BY')^
INSERT INTO REPL$KEYWORDS VALUES (1,'CHAR')^
INSERT INTO REPL$KEYWORDS VALUES (1,'CHECK')^
INSERT INTO REPL$KEYWORDS VALUES (1,'CLUSTER')^
INSERT INTO REPL$KEYWORDS VALUES (1,'COLUMN')^
INSERT INTO REPL$KEYWORDS VALUES (1,'COMMENT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'COMPRESS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'CONNECT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'CREATE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'CURRENT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'DATE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'DECIMAL')^
INSERT INTO REPL$KEYWORDS VALUES (1,'DEFAULT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'DELETE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'DESC')^
INSERT INTO REPL$KEYWORDS VALUES (1,'DISTINCT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'DROP')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ELSE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'EXCLUSIVE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'EXISTS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'FILE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'FLOAT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'FOR')^
INSERT INTO REPL$KEYWORDS VALUES (1,'FROM')^
INSERT INTO REPL$KEYWORDS VALUES (1,'GRANT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'GROUP')^
INSERT INTO REPL$KEYWORDS VALUES (1,'HAVING')^
INSERT INTO REPL$KEYWORDS VALUES (1,'IDENTIFIED')^
INSERT INTO REPL$KEYWORDS VALUES (1,'IMMEDIATE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'IN')^
INSERT INTO REPL$KEYWORDS VALUES (1,'INCREMENT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'INDEX')^
INSERT INTO REPL$KEYWORDS VALUES (1,'INITIAL')^
INSERT INTO REPL$KEYWORDS VALUES (1,'INSERT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'INTEGER')^
INSERT INTO REPL$KEYWORDS VALUES (1,'INTERSECT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'INTO')^
INSERT INTO REPL$KEYWORDS VALUES (1,'IS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'LEVEL')^
INSERT INTO REPL$KEYWORDS VALUES (1,'LIKE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'LOCK')^
INSERT INTO REPL$KEYWORDS VALUES (1,'LONG')^
INSERT INTO REPL$KEYWORDS VALUES (1,'MAXEXTENTS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'MINUS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'MLSLABEL')^
INSERT INTO REPL$KEYWORDS VALUES (1,'MODE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'MODIFY')^
INSERT INTO REPL$KEYWORDS VALUES (1,'NOAUDIT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'NOCOMPRESS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'NOT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'NOWAIT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'NULL')^
INSERT INTO REPL$KEYWORDS VALUES (1,'NUMBER')^
INSERT INTO REPL$KEYWORDS VALUES (1,'OF')^
INSERT INTO REPL$KEYWORDS VALUES (1,'OFFLINE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ON')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ONLINE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'OPTION')^
INSERT INTO REPL$KEYWORDS VALUES (1,'OR')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ORDER')^
INSERT INTO REPL$KEYWORDS VALUES (1,'PCTFREE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'PRIOR')^
INSERT INTO REPL$KEYWORDS VALUES (1,'PRIVILEGES')^
INSERT INTO REPL$KEYWORDS VALUES (1,'PUBLIC')^
INSERT INTO REPL$KEYWORDS VALUES (1,'RAW')^
INSERT INTO REPL$KEYWORDS VALUES (1,'RENAME')^
INSERT INTO REPL$KEYWORDS VALUES (1,'RESOURCE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'REVOKE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ROW')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ROWID')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ROWNUM')^
INSERT INTO REPL$KEYWORDS VALUES (1,'ROWS')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SELECT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SESSION')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SET')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SHARE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SIZE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SMALLINT')^
INSERT INTO REPL$KEYWORDS VALUES (1,'START')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SUCCESSFUL')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SYNONYM')^
INSERT INTO REPL$KEYWORDS VALUES (1,'SYSDATE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'TABLE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'THEN')^
INSERT INTO REPL$KEYWORDS VALUES (1,'TO')^
INSERT INTO REPL$KEYWORDS VALUES (1,'TRIGGER')^
INSERT INTO REPL$KEYWORDS VALUES (1,'UID')^
INSERT INTO REPL$KEYWORDS VALUES (1,'UNION')^
INSERT INTO REPL$KEYWORDS VALUES (1,'UNIQUE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'UPDATE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'USER')^
INSERT INTO REPL$KEYWORDS VALUES (1,'VALIDATE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'VALUES')^
INSERT INTO REPL$KEYWORDS VALUES (1,'VARCHAR')^
INSERT INTO REPL$KEYWORDS VALUES (1,'VARCHAR2')^
INSERT INTO REPL$KEYWORDS VALUES (1,'VIEW')^
INSERT INTO REPL$KEYWORDS VALUES (1,'WHENEVER')^
INSERT INTO REPL$KEYWORDS VALUES (1,'WHERE')^
INSERT INTO REPL$KEYWORDS VALUES (1,'WITH')^

INSERT INTO REPL$KEYWORDS VALUES (3,'ACTION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ACTIVE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ADD')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ADMIN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'AFTER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ALL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ALTER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'AND')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ANY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'AS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ASC')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ASCENDING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'AT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'AUTO')^
INSERT INTO REPL$KEYWORDS VALUES (3,'AVG')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BASE_NAME')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BEFORE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BEGIN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BETWEEN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BIGINT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BLOB')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BLOCK')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BREAK')^
INSERT INTO REPL$KEYWORDS VALUES (3,'BY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CACHE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CASCADE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CASE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CAST')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CHAR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CHAR_LENGTH')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CHARACTER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CHARACTER_LENGTH')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CHECK')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CHECK_POINT_LENGTH')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CLOSE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'COALESCE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'COLLATE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'COLUMN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'COMMIT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'COMMITTED')^
INSERT INTO REPL$KEYWORDS VALUES (3,'COMPUTED')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CONDITIONAL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CONNECT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CONSTRAINT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CONTAINING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'COUNT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CREATE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CROSS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CSTRING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURRENT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURRENT_CONNECTION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURRENT_DATE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURRENT_ROLE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURRENT_TIME')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURRENT_TIMESTAMP')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURRENT_TRANSACTION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURRENT_USER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'CURSOR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DATABASE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DATE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DAY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DEBUG')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DEC')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DECIMAL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DECLARE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DEFAULT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DELETE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DELETING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DESC')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DESCENDING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DESCRIPTOR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DIFFERENCE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DISCONNECT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DISTINCT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DO')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DOMAIN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DOUBLE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'DROP')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ELSE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'END')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ENTRY_POINT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ESCAPE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'EXCEPTION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'EXECUTE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'EXISTS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'EXIT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'EXTERNAL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'EXTRACT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FETCH')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FILE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FILTER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FIRST')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FLOAT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FOR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FOREIGN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FREE_IT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FROM')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FULL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'FUNCTION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'GDSCODE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'GENERATOR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'GEN_ID')^
INSERT INTO REPL$KEYWORDS VALUES (3,'GLOBAL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'GRANT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'GROUP')^
INSERT INTO REPL$KEYWORDS VALUES (3,'GROUP_COMMIT_WAIT_TIME')^
INSERT INTO REPL$KEYWORDS VALUES (3,'HAVING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'HOUR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'IF')^
INSERT INTO REPL$KEYWORDS VALUES (3,'IIF')^
INSERT INTO REPL$KEYWORDS VALUES (3,'IN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INACTIVE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INDEX')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INNER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INPUT_TYPE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INSENSITIVE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INSERT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INSERTING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INTEGER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'INTO')^
INSERT INTO REPL$KEYWORDS VALUES (3,'IS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ISOLATION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'JOIN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'KEY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LAST')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LEADING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LEAVE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LEFT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LENGTH')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LEVEL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LIKE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LIST')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LOGFILE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LOG_BUFFER_SIZE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LONG')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LOWER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MANUAL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MATCHED')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MATCHING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MAX')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MAXIMUM_SEGMENT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MERGE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MESSAGE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MIN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MINUTE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MODULE_NAME')^
INSERT INTO REPL$KEYWORDS VALUES (3,'MONTH')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NAMES')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NATIONAL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NATURAL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NCHAR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NEXT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NO')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NOT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NULLIF')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NULL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NULLS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'LOCK')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NUMERIC')^
INSERT INTO REPL$KEYWORDS VALUES (3,'NUM_LOG_BUFFERS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'OCTET_LENGTH')^
INSERT INTO REPL$KEYWORDS VALUES (3,'OF')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ON')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ONLY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'OPEN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'OPTION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'OR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ORDER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'OUTER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'OUTPUT_TYPE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'OVERFLOW')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PAGE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PAGES')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PAGE_SIZE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PARAMETER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PASSWORD')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PLAN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'POSITION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'POST_EVENT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PRECISION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PRESERVE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PRIMARY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PRIVILEGES')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PROCEDURE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'PROTECTED')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RAW_PARTITIONS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RDB$DB_KEY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'READ')^
INSERT INTO REPL$KEYWORDS VALUES (3,'REAL')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RECORD_VERSION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RECREATE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RECURSIVE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'REFERENCES')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RELEASE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RESERV')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RESERVING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RESTART')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RESTRICT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RETAIN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RETURNING_VALUES')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RETURNS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'REVOKE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'RIGHT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ROLE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ROLLBACK')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ROW_COUNT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'ROWS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SAVEPOINT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SCALAR_ARRAY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SCHEMA')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SECOND')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SEGMENT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SELECT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SENSITIVE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SEQUENCE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SET')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SHADOW')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SHARED')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SINGULAR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SIZE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SKIP')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SMALLINT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SNAPSHOT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SOME')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SORT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SQLCODE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'STABILITY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'STARTING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'STARTS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'STATEMENT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'STATISTICS')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SUBSTRING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SUB_TYPE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SUM')^
INSERT INTO REPL$KEYWORDS VALUES (3,'SUSPEND')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TABLE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TEMPORARY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'THEN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TIME')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TIMESTAMP')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TO')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TRAILING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TRANSACTION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TRIGGER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TRIM')^
INSERT INTO REPL$KEYWORDS VALUES (3,'TYPE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'UNCOMMITTED')^
INSERT INTO REPL$KEYWORDS VALUES (3,'UNION')^
INSERT INTO REPL$KEYWORDS VALUES (3,'UNIQUE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'UPDATE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'UPDATING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'UPPER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'USER')^
INSERT INTO REPL$KEYWORDS VALUES (3,'USING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'VALUE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'VALUES')^
INSERT INTO REPL$KEYWORDS VALUES (3,'VARCHAR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'VARIABLE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'VARYING')^
INSERT INTO REPL$KEYWORDS VALUES (3,'VIEW')^
INSERT INTO REPL$KEYWORDS VALUES (3,'WAIT')^
INSERT INTO REPL$KEYWORDS VALUES (3,'WEEKDAY')^
INSERT INTO REPL$KEYWORDS VALUES (3,'WHEN')^
INSERT INTO REPL$KEYWORDS VALUES (3,'WHERE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'WHILE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'WITH')^
INSERT INTO REPL$KEYWORDS VALUES (3,'WORK')^
INSERT INTO REPL$KEYWORDS VALUES (3,'WRITE')^
INSERT INTO REPL$KEYWORDS VALUES (3,'YEAR')^
INSERT INTO REPL$KEYWORDS VALUES (3,'YEARDAY')^

ALTER PROCEDURE REPL$NOTIFY(THETYPE INTEGER)
AS
BEGIN
  IF (THETYPE = 1) THEN
    POST_EVENT 'RELOAD';
  ELSE IF (THETYPE = 2) THEN
    POST_EVENT 'REPLNOW';
  ELSE IF (THETYPE = 4) THEN
    POST_EVENT 'EXITNOW';
  ELSE IF (THETYPE = 7) THEN
    POST_EVENT 'REPLSTATS';
  ELSE IF (THETYPE = 8) THEN
    POST_EVENT 'REPLERROR';
END^

ALTER PROCEDURE REPL$CLONETARGET (REPLNO INTEGER, TGTDBNO INTEGER, NEWREPLNO INTEGER, NEWTGTDBNO INTEGER)
AS
  DECLARE VARIABLE OLDRLNNO INTEGER;
  DECLARE VARIABLE NEWRLNNO INTEGER;
  DECLARE VARIABLE NEWSORTKEY INTEGER;
BEGIN
  if (NOT EXISTS(select * from REPL$subscribeddb where replno = :newreplno and dbno = :newtgtdbno)) then 
  begin
    NEWSORTKEY = 0;
    select MAX(SORT_KEY)+1 FROM REPL$SUBSCRIBEDDB WHERE REPLNO=:NEWREPLNO INTO :NEWSORTKEY;
    insert into REPL$subscribeddb(replno,dbno,username,psword,userrole,UseDefaultLogging,LogFileName,LogToFile,LogToWindow,sort_key)
    select :newreplno,:newtgtdbno,username,psword,userrole,UseDefaultLogging,LogFileName,LogToFile,LogToWindow,:newsortkey from REPL$subscribeddb where replno = :replno and dbno = :tgtdbno;
  end
  FOR SELECT RELATIONNO FROM REPL$RELATIONS WHERE REPLNO = :REPLNO AND TGTDBNO = :TGTDBNO INTO :OLDRLNNO DO 
  BEGIN
    NEWRLNNO = GEN_ID(REPL$RELATIONGEN,1);
    INSERT INTO REPL$RELATIONS (REPLNO,TGTDBNO,RELATIONNO,RELATIONSCHEMA,RELATIONNAME,COMMENTS,DISABLED, TIMEFIELDNAME, CONDITION,TARGETSCHEMA,TARGETNAME,TARGETTYPE,SEP,OPS,SORT_KEY,CONFLICTMETHOD,FKBEHAVIOR)
    SELECT :NEWREPLNO,:NEWTGTDBNO,:NEWRLNNO,RELATIONSCHEMA,RELATIONNAME, COMMENTS, DISABLED, TIMEFIELDNAME, CONDITION, TARGETSCHEMA, TARGETNAME, TARGETTYPE, SEP, OPS, SORT_KEY,CONFLICTMETHOD,FKBEHAVIOR FROM REPL$RELATIONS
      WHERE REPLNO = :REPLNO AND TGTDBNO = :TGTDBNO AND RELATIONNO = :OLDRLNNO;
    INSERT INTO REPL$KEYFIELDS (REPLNO, RELATIONNO, TGTDBNO, FIELDNO, FIELDNAME, TARGETNAME)
    SELECT :NEWREPLNO , :NEWRLNNO , :NEWTGTDBNO, FIELDNO, FIELDNAME, TARGETNAME FROM REPL$KEYFIELDS
      WHERE REPLNO = :REPLNO AND TGTDBNO = :TGTDBNO AND RELATIONNO = :OLDRLNNO;
    INSERT INTO REPL$DATAFIELDS (REPLNO, RELATIONNO, TGTDBNO, FIELDNO, FIELDNAME, TARGETNAME)
    SELECT :NEWREPLNO, :NEWRLNNO, :NEWTGTDBNO, FIELDNO, FIELDNAME, TARGETNAME FROM REPL$DATAFIELDS
      WHERE REPLNO = :REPLNO AND TGTDBNO = :TGTDBNO AND RELATIONNO = :OLDRLNNO;
  END
  INSERT INTO REPL$SEQUENCES (REPLNO,TGTDBNO,SOURCESCHEMA,SOURCENAME,TARGETSCHEMA,TARGETNAME)
    SELECT :NEWREPLNO,:NEWTGTDBNO,SOURCESCHEMA,SOURCENAME,TARGETSCHEMA,TARGETNAME FROM REPL$SEQUENCES
      WHERE REPLNO=:REPLNO AND TGTDBNO=:TGTDBNO;
END^

CREATE TRIGGER REPL$SETSEQENCENO FOR REPL$SEQUENCES
ACTIVE BEFORE INSERT POSITION 0 
AS 
BEGIN 
  IF (NEW.SEQNO IS NULL) THEN 
    NEW.SEQNO = GEN_ID(REPL$RELATIONGEN,1);
END^

ALTER TRIGGER REPL$CASCADEPUBLISHEDDELETE
ACTIVE BEFORE DELETE POSITION 0 
AS 
BEGIN
 DELETE FROM REPL$RELATIONS WHERE REPLNO=OLD.REPLNO;
 DELETE FROM REPL$SEQUENCES WHERE REPLNO=OLD.REPLNO;
 DELETE FROM REPL$SUBSCRIBEDDB WHERE REPLNO=OLD.REPLNO;
END^

ALTER TRIGGER REPL$LICENSE_DEL INACTIVE^
DELETE FROM REPL$LICENSES^
ALTER TABLE REPL$LICENSES ADD LICENSEKEY3 VARCHAR(300) CHARACTER SET NONE NOT NULL,
DROP LICENSEKEY^
ALTER TRIGGER REPL$LICENSE_DEL ACTIVE BEFORE DELETE POSITION 0 AS BEGIN IF (UPPER(OLD.LICENSEID)='EVAL') THEN EXCEPTION REPL$LICENSE; END^

UPDATE REPL$DATABASES SET TIMEFIELDNAME=UPPER(TIMEFIELDNAME) WHERE TIMEFIELDNAME NOT CONTAINING '"'^
UPDATE REPL$RELATIONS SET TIMEFIELDNAME=UPPER(TIMEFIELDNAME) WHERE TIMEFIELDNAME NOT CONTAINING '"'^

UPDATE REPL$CONFIG SET VERSION=41,FKBEHAVIOR=0,FPS_TIMEOUT=0^
